#! /usr/bin/perl

################################################################################
# Basic Visit Counter v.1.01                                                   #
#                                                                              #
# NOTE: This counter might not be able to compensate for multiple              #
#       simultaneous visitors. It's just a rough sketch of a counter           #
#       for low-traffic sites. Nothing fancy and no real accounting            #
#       of IPs as the last visitor's IP and time overwrites the                #
#       previous visitor's IP. On low-traffic sites, this counter              #
#       may (or may not) help keep the counter from incrementing on            #
#       reloads.                                                               #
#                                                                              #
# THIS COUNTER MIGHT NOT BE VERY ACCURATE IN ALL SITUATIONS.                   #
# This counter also assumes that the visitor has JavaScript enabled.           #
#                                                                              #
# See the README.txt file for more info on setup and use.                      #
#                                                                              #                                                    #
# CHANGELOG:                                                                   #
# ----------                                                                   #
# December 11, 2004 - Created.                                                 #
# December 18, 2004 - Bug Fix: Counter not updating for all new IPs [Tika]     #
#                                                                              #
################################################################################

# Config
use strict;
use CGI ':standard';
use CGI::Carp qw(fatalsToBrowser);  # Descriptive Error Messages
$CGI::POST_MAX = 1024 * 100;        # max 100K posts - DOS attack Prevention

# Variables
my $tlimit     = 120;               # set this variable in seconds
my $ip = $ENV{'REMOTE_ADDR'};       # Retrieve user's IP address
my $ctime = time;                   # current time
my $iplog = 'counteriplog.txt';     # user IP and current time log
my $countlog = 'count.txt';         # counter file

# Get current count
open COUNT, $countlog || die "Can't Open Count File, Error : $!\n";
my $count = <COUNT>;
close COUNT;
$count =~ s/\n//;

# NOTE: Can't use open IP, "+>$logfile" as no data would be written to file
#       for some odd reason. So this is done in two steps instead.
open IP, $iplog || die "Can't Open IP Log File, Error : $!\n";
  my @read_data = <IP>;
close IP;

open(IP,">$iplog") || die "Can't Write Log File, Error: $!\n";
  print IP "$ctime\n$ip\n";
close(IP);

# Check IP address and time, then add if not a reload or visited within specified time
$read_data[1] =~ s/\n//;
$read_data[0] =~ s/\n//;
my $flag = 1;
if ($ip == $read_data[1]) {
  $flag = 0;
  if ($ctime >= ($read_data[0] + $tlimit)) {
    $flag = 1;
  }
}

# Update Counter if all checked ok
if ($flag==1) {
  $count++;
    open(COUNT,">$countlog") || die "Can't Write Count File, Error : $!\n";
      print COUNT "$count";
    close(COUNT);
}

# Pad with 0's 6 places
my $padded = sprintf("%06d", $count);

# Print number to the page
print "Cache-Control: no-cache\n";
print "Pragma: no-cache\n";
print "Content-type: application/x-javascript\n\n";
print "document.write(\"".$padded."\");";
